﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;

namespace HeuristicLab.Problems.Instances.Regression {
  public class KeijzerInstanceProvider : ArtificialRegressionInstanceProvider, IProblemInstanceProvider<RegressionData> {
    public override string Name {
      get { return "Keijzer Benchmark Problems"; }
    }
    public override string Description {
      get { return ""; }
    }
    public override Uri WebLink {
      get { return new Uri("http://groups.csail.mit.edu/EVO-DesignOpt/GPBenchmarks/"); }
    }
    public override string ReferencePublication {
      get { return ""; }
    }

    public override IEnumerable<IDataDescriptor> GetDataDescriptors() {
      List<IDataDescriptor> descriptorList = new List<IDataDescriptor>();
      descriptorList.Add(new KeijzerFunctionEight());
      return descriptorList;
    }

    /*#region delete after test
    public RegressionData LoadData(IDataDescriptor descriptor) {
      throw new NotImplementedException();
    }

    public RegressionData LoadData(string path) {
      TableFileParser csvFileParser = new TableFileParser();
      csvFileParser.Parse(path);

      RegressionData regData = new RegressionData();
      regData.Name = path;
      regData.InputVariables = new List<string>(csvFileParser.VariableNames);
      regData.TargetVariable = csvFileParser.VariableNames.Last();
      //convert to multidimensional array
      double[][] values = csvFileParser.Values.Cast<double[]>().ToArray();
      regData.Values = new double[values.GetLength(0), values.GetLength(1)];
      for (int i = 0; i < values.GetLength(0); i++) {
        for (int j = 0; j < values.GetLength(1); j++) {
          regData.Values[i, j] = values[i][j];
        }
      }

      int trainingPartEnd = csvFileParser.Rows * 2 / 3;
      regData.TrainingPartitionStart = 0;
      regData.TrainingPartitionEnd = trainingPartEnd;
      regData.TestPartitionStart = trainingPartEnd;
      regData.TestPartitionEnd = csvFileParser.Rows;
      return regData;
    }

    public void SaveData(RegressionData instance, string path) {
      StringBuilder strBuilder = new StringBuilder();

      foreach (var variable in instance.InputVariables) {
        strBuilder.Append(variable + ";");
      }
      strBuilder.Remove(strBuilder.Length - 1, 1);
      strBuilder.AppendLine();

      double[,] values = instance.Values;

      for (int i = 0; i < values.GetLength(0); i++) {
        for (int j = 0; j < values.GetLength(1); j++) {
          strBuilder.Append(values[i, j] + ";");
        }
        strBuilder.Remove(strBuilder.Length - 1, 1);
        strBuilder.AppendLine();
      }

      using (StreamWriter writer = new StreamWriter(path)) {
        writer.Write(strBuilder);
      }
    }
    #endregion

    #region IProblemInstanceProvider<RegressionData> Members

    public IProblemInstanceConsumer<RegressionData> Consumer {
      get {
        return new RegressionProblem();
      }
      set {
        throw new NotImplementedException();
      }
    }

    #endregion       */
  }
}
